import { Type as Constructor } from '@nestjs/common';
import { ApiPropertyOptions } from '@nestjs/swagger';
import { OptionalToNullable } from "../../../utils/types";
export * from '@nestjs/swagger';
export declare const ApiProperty: (args?: (ApiPropertyOptions & {
    transform?: boolean | undefined;
}) | undefined) => <TFunction extends Function, Y>(target: object | TFunction, propertyKey?: string | symbol | undefined, descriptor?: TypedPropertyDescriptor<Y> | undefined) => void;
export declare const ApiPropertyOptional: (args?: (ApiPropertyOptions & {
    disableDefaultValidation?: boolean | undefined;
    transform?: boolean | undefined;
}) | undefined) => <TFunction extends Function, Y>(target: object | TFunction, propertyKey?: string | symbol | undefined, descriptor?: TypedPropertyDescriptor<Y> | undefined) => void;
export interface FieldConfig {
    required?: boolean;
}
export declare const PartialType: <T>(classRef: Constructor<T>) => Constructor<Partial<T>>;
export declare const RequiredType: <T extends object>(classRef: Constructor<T>) => Constructor<OptionalToNullable<T>>;
