"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequiredType = exports.PartialType = exports.ApiPropertyOptional = exports.ApiProperty = void 0;
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const class_transformer_1 = require("class-transformer");
const class_validator_1 = require("class-validator");
const validator_1 = require("./validator");
const core_1 = require("..");
const model_properties_accessor_1 = require("@nestjs/swagger/dist/services/model-properties-accessor");
const mapped_types_1 = require("@nestjs/mapped-types");
const constants_1 = require("@nestjs/swagger/dist/constants");
const plugin_constants_1 = require("@nestjs/swagger/dist/plugin/plugin-constants");
__exportStar(require("@nestjs/swagger"), exports);
function getAdditionalDecorators(options) {
    const additionalDecorators = [(0, class_transformer_1.Expose)()];
    if (options?.type) {
        const { type, transform } = options;
        if (type === Boolean) {
            if (transform) {
                additionalDecorators.push((0, core_1.TypeBoolean)());
            }
            additionalDecorators.push((0, class_validator_1.IsBoolean)({
                each: options.isArray,
            }));
        }
        else if (type === Number) {
            if (transform) {
                additionalDecorators.push((0, class_transformer_1.Type)(() => Number));
            }
            additionalDecorators.push((0, class_validator_1.IsNumber)(undefined, {
                each: options.isArray,
            }));
        }
        else if (type === Date) {
            additionalDecorators.push((0, class_transformer_1.Type)(() => type), (0, class_validator_1.IsDate)({
                each: options.isArray,
            }));
        }
        else if (type === String) {
            if (transform) {
                additionalDecorators.push((0, class_transformer_1.Type)(() => String));
            }
            additionalDecorators.push((0, class_validator_1.IsString)({
                each: options.isArray,
            }));
        }
        else if (typeof type === 'function') {
            if (options.isArray) {
                additionalDecorators.push((0, class_validator_1.ValidateNested)({ each: true }), (0, class_transformer_1.Type)(() => type));
            }
            else {
                additionalDecorators.push((0, class_validator_1.ValidateNested)(), (0, class_transformer_1.Type)(() => type));
            }
        }
    }
    return additionalDecorators;
}
const ApiProperty = (args) => {
    const nullable = args?.nullable ?? false;
    const decorators = [
        (0, class_transformer_1.Expose)(),
        (0, validator_1.IsDefined)(),
        (0, swagger_1.ApiProperty)({ required: true, nullable, ...args }),
        ...getAdditionalDecorators(args),
    ];
    if (!nullable) {
        decorators.push((0, validator_1.IsNotNull)());
    }
    return (0, common_1.applyDecorators)(...decorators);
};
exports.ApiProperty = ApiProperty;
const ApiPropertyOptional = (args) => {
    const nullable = args?.nullable ?? true;
    const decorators = [
        (0, class_transformer_1.Expose)(),
        (0, swagger_1.ApiPropertyOptional)({ required: false, nullable, ...args }),
        ...getAdditionalDecorators(args),
    ];
    if (args?.disableDefaultValidation) {
        decorators.push(nullable ? (0, class_validator_1.IsOptional)() : (0, validator_1.OptionalNotNullable)());
    }
    return (0, common_1.applyDecorators)(...decorators);
};
exports.ApiPropertyOptional = ApiPropertyOptional;
const modelPropertiesAccessor = new model_properties_accessor_1.ModelPropertiesAccessor();
function TypeBuilder(classRef, overrides) {
    const fields = modelPropertiesAccessor.getModelProperties(classRef.prototype);
    class ModifiedTypeClass {
        constructor() {
            (0, mapped_types_1.inheritPropertyInitializers)(this, classRef);
        }
    }
    function applyDecorator(key, metadata) {
        const config = overrides != null ? overrides[key] : undefined;
        const required = config?.required ?? metadata?.required ?? true;
        const nullable = metadata?.nullable ?? true;
        const decorators = [
            (0, swagger_1.ApiProperty)({
                ...metadata,
                required,
                nullable,
            }),
        ];
        if (nullable) {
            decorators.push((0, class_validator_1.IsOptional)());
        }
        else {
            decorators.push((0, validator_1.OptionalNotNullable)());
        }
        const decorator = (0, common_1.applyDecorators)(...decorators);
        decorator(ModifiedTypeClass.prototype, key);
    }
    (0, mapped_types_1.inheritValidationMetadata)(classRef, ModifiedTypeClass);
    (0, mapped_types_1.inheritTransformationMetadata)(classRef, ModifiedTypeClass);
    fields.forEach((key) => {
        const metadata = Reflect.getMetadata(constants_1.DECORATORS.API_MODEL_PROPERTIES, classRef.prototype, key) || {};
        applyDecorator(key, metadata);
    });
    if (ModifiedTypeClass[plugin_constants_1.METADATA_FACTORY_NAME]) {
        const pluginFields = Object.keys(ModifiedTypeClass[plugin_constants_1.METADATA_FACTORY_NAME]());
        pluginFields.forEach((key) => applyDecorator(key));
    }
    return ModifiedTypeClass;
}
const PartialType = (classRef) => {
    const fields = modelPropertiesAccessor.getModelProperties(classRef.prototype);
    const fieldConfigs = fields.reduce((agg, key) => {
        const metadata = Reflect.getMetadata(constants_1.DECORATORS.API_MODEL_PROPERTIES, classRef.prototype, key) || {};
        const fieldConfig = {
            nullable: metadata?.nullable,
            required: false,
        };
        return {
            ...agg,
            [key]: fieldConfig,
        };
    }, {});
    return TypeBuilder(classRef, fieldConfigs);
};
exports.PartialType = PartialType;
const RequiredType = (classRef) => {
    const fields = modelPropertiesAccessor.getModelProperties(classRef.prototype);
    const fieldConfigs = fields.reduce((agg, key) => {
        const metadata = Reflect.getMetadata(constants_1.DECORATORS.API_MODEL_PROPERTIES, classRef.prototype, key) || {};
        const fieldConfig = {
            nullable: metadata.nullable || metadata.default != null,
            required: true,
        };
        return {
            ...agg,
            [key]: fieldConfig,
        };
    }, {});
    return TypeBuilder(classRef, fieldConfigs);
};
exports.RequiredType = RequiredType;
//# sourceMappingURL=api.js.map