import { ArgumentMetadata, PipeTransform } from '@nestjs/common';
import { Reflector } from '@nestjs/core';
import { ValidatorOptions } from 'class-validator';
export declare class ValidationPipe implements PipeTransform<any> {
    private reflector;
    constructor(reflector: Reflector);
    transform(value: any, metadata: ArgumentMetadata): Promise<any>;
    private static transformValidationError;
}
/**
 * Allow setting custom ValidationOptions per domain model
 * @param validateOptions
 * usage:
 *
 * @ValidateOptions({ transform: false })
 * class CatDto {
 *
 * }
 */
export declare const ValidateOptions: (validateOptions: ValidatorOptions) => import("@nestjs/common").CustomDecorator<string>;
