"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestLogger = void 0;
const common_1 = require("@nestjs/common");
const async_context_1 = require("@nestjs-steroids/async-context");
const root_logger_1 = require("./root-logger");
const middlewares_1 = require("../middlewares");
let RequestLogger = class RequestLogger {
    constructor(ac, rootLogger) {
        this.ac = ac;
        this.rootLogger = rootLogger;
    }
    get logger() {
        const traceId = this.ac.get(middlewares_1.TRACE_ID);
        return this.rootLogger.child({
            traceId,
        });
    }
    info(message, ...optionalParams) {
        this.log(message, ...optionalParams);
    }
    /**
     * Write a 'log' level log. equivalent to info
     */
    log(message, ...optionalParams) {
        this.logger.info(message, ...optionalParams);
    }
    /**
     * Write an 'error' level log.
     */
    error(message, ...optionalParams) {
        this.logger.error(message, ...optionalParams);
    }
    /**
     * Write a 'warn' level log.
     */
    warn(message, ...optionalParams) {
        this.logger.warn(message, ...optionalParams);
    }
    /**
     * Write a 'debug' level log.
     */
    debug(message, ...optionalParams) {
        this.logger.debug(message, ...optionalParams);
    }
    /**
     * Write a 'verbose' level log.
     */
    verbose(message, ...optionalParams) {
        this.logger.verbose(message, ...optionalParams);
    }
};
RequestLogger = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [async_context_1.AsyncContext,
        root_logger_1.RootLogger])
], RequestLogger);
exports.RequestLogger = RequestLogger;
//# sourceMappingURL=request-logger.js.map