import { LoggerService } from '@nestjs/common';
import { Logger } from 'winston';
import { BootstrapOptions } from "../interface";
export declare class RootLogger implements LoggerService {
    private readonly bootstrapOptions;
    private logger;
    constructor(bootstrapOptions: BootstrapOptions);
    info(message: any, ...optionalParams: any[]): void;
    child(options: object): Logger;
    /**
     * Write a 'log' level log. equivalent to info
     */
    log(message: any, ...optionalParams: any[]): void;
    /**
     * Write an 'error' level log.
     */
    error(message: any, ...optionalParams: any[]): void;
    /**
     * Write a 'warn' level log.
     */
    warn(message: any, ...optionalParams: any[]): void;
    /**
     * Write a 'debug' level log.
     */
    debug(message: any, ...optionalParams: any[]): void;
    /**
     * Write a 'verbose' level log.
     */
    verbose(message: any, ...optionalParams: any[]): void;
    get stream(): {
        write(message: string): void;
    };
}
