"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RootLogger = void 0;
const common_1 = require("@nestjs/common");
const logger_1 = require("./logger");
const tokens_1 = require("../tokens");
let RootLogger = class RootLogger {
    constructor(bootstrapOptions) {
        this.bootstrapOptions = bootstrapOptions;
        this.logger = logger_1.logger.child({
            name: bootstrapOptions.name,
            version: bootstrapOptions.version,
        });
    }
    info(message, ...optionalParams) {
        this.log(message, ...optionalParams);
    }
    child(options) {
        return this.logger.child(options);
    }
    /**
     * Write a 'log' level log. equivalent to info
     */
    log(message, ...optionalParams) {
        this.logger.info(message, ...optionalParams);
    }
    /**
     * Write an 'error' level log.
     */
    error(message, ...optionalParams) {
        this.logger.error(message, ...optionalParams);
    }
    /**
     * Write a 'warn' level log.
     */
    warn(message, ...optionalParams) {
        this.logger.warn(message, ...optionalParams);
    }
    /**
     * Write a 'debug' level log.
     */
    debug(message, ...optionalParams) {
        this.logger.debug(message, ...optionalParams);
    }
    /**
     * Write a 'verbose' level log.
     */
    verbose(message, ...optionalParams) {
        this.logger.verbose(message, ...optionalParams);
    }
    get stream() {
        const { logger: rootLogger } = this;
        return {
            write(message) {
                rootLogger.info(message);
            },
        };
    }
};
RootLogger = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(tokens_1.BOOTSTRAP_OPTIONS_TOKEN)),
    __metadata("design:paramtypes", [Object])
], RootLogger);
exports.RootLogger = RootLogger;
//# sourceMappingURL=root-logger.js.map