"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.serialize = exports.convertToPlain = exports.convertToInstance = void 0;
const class_transformer_1 = require("class-transformer");
const defaultOptions = {
    excludeExtraneousValues: true,
    exposeUnsetFields: false,
};
/**
 * Convert a plain object to a class instance
 */
const convertToInstance = (classType, object, options = {}) => (0, class_transformer_1.plainToClass)(classType, object, {
    ...defaultOptions,
    ...options,
});
exports.convertToInstance = convertToInstance;
/**
 * Convert a class instance to a plain object
 */
const convertToPlain = (object, options = {}) => (0, class_transformer_1.classToPlain)(object, {
    ...defaultOptions,
    ...options,
});
exports.convertToPlain = convertToPlain;
/**
 * Convert a plain object to a class instance and then serialise the class instance to json object
 */
const serialize = (classType, object, options = {}) => {
    return (0, exports.convertToPlain)((0, exports.convertToInstance)(classType, object, options), options);
};
exports.serialize = serialize;
//# sourceMappingURL=serialize.js.map